.TH SNMPFS 4
.SH NAME
snmpfs \- snmp manager as a file system
.SH SYNOPSIS
.I snmpfs 
[
.B -n
] [
.B -s
.I srv
] [
.B -r 
.I root-oid
] [
.B -m
.I mntpnt
]
.B host
.SH DESCRIPTION
.I Snmpfs
uses the Simple Network Managment Protocol (snmp) to walk the list
of Object IDs (OISs) advertised by the named host, and creats a
synthetic filesystem based on this data. Parameter OIDs
(dotted lists of decimal numbers) are used to create
the hierarchy, and reading and writing files performs a
.I Put
or
.I Get
operation on the relevant object.
.PP
Directory and file names are mapped, when possible,
from numeric IDs to names derrived from the MIB
by the map files found in the directory /lib/snmp.
.PP
When files are read the object's value is prefixed
by a single word describing the value's format.
When writing a file the same format should be used.
.PP
The valid format descriptors are: int, counter, gauge,
octstr, objid, ipaddr. These types are explained in
RFC1098.
The command line options are:
.TP
.B -n
Disable the numeric to name mapping of known OIDs.
.TP
.B -m \fI mntpnt
set the mount point for the synthetic filesystem; 
the default is
.BR /n/snmp .
.TP
.B -s \fI srvname
set the mount point for the published \fI/srv\fR file
the default is not to publish a \fI/srv\fR file.
.TP
.B "-r root"
Start the walk of the host from the OID
.B root
rather than the default: 1.3.6.1.2.
.SH FILES
/lib/snmp/*.map - a flat file databases mapping SNMP OIDs to names.
.br
/sys/src/cmd/snmpfs/*
.SH BUGS
.I Snmpfs
uses the SNMP V1 protocol, this ensures it is compatibile with
both V1 and V2 agents however this means it is unable to take
advantage of the performance improvements offered by V2 (GetBulk).
.PP
Map files should be extracted mechanicially extracted from MIBs,
but the flat namespace of MIBs makes the simplifying the names
by automaticially not tractable.
